/*
 * CTCSS.c
 *
 *  Created on: 16.03.2016
 *      Author: DL9MWE
 *      29.03.2016
 */
#include "main.h"

// Teilerwerte fr die CTCSS-Erzeugung
// (minimal 450 => 270Hz; max. 2500 => 49Hz)
// Yaesu-Reihenfolge...
unsigned int const teiler_tabelle[43] = {
//  97.4, 91.5, 88.5, 85.4, 82.5, 79.7,   77, 74.4, 71.9, 67,
	1283, 1366, 1412, 1464, 1515, 1568, 1623, 1680, 1739, 1866,
// 250.3, 241.8, 233.6, 225.7, 218.1, 210.7, 203.5, 192.8, 186.2, 179.9,
	 499,   517,   535,   554,   573,   593,   614,   647,   671,   695,
// 173.8, 167.9, 162.2, 156.7, 151.4, 146.2, 141.3, 136.5, 131.8, 127.3,
	 719,   744,   771,   798,   826,   855,   885,   916,   948,   982,
//    123, 118.8, 114.8, 110.9, 107.2, 103.5,  100, 94.8, 88.5, 82.5,
	 1016,  1052,  1089,  1127,  1166,  1208, 1250, 1319, 1412, 1515,
//     77, 71.9,   67
	 1623, 1739, 1866
};

void vCTCSS_start(void) {
	unsigned index;
	index = ((unsigned int)PORTFT736_IN & 0x3F) - 20;	// Bits 0 bis 5 bestimmen den CTCSS-Ton
														// allerdings macht YAESU das etwas verwirrend... siehe Tabelle
	if(index>=43) index = 3;					// 85,4Hz ist default
	timer_count = teiler_tabelle[index];		// Teilerfaktor fr diesen CTCSS-Ton aus der Tabelle lesen
	vSPI_init();
	vDAC_init();
	vtimer_init();
	_BIS_SR(GIE);								// interrupts enabled: Ton erzeugen
}

void vCTCSS_end(void) {
	while(DAC_stuetzstelle != 0);				// warten auf Nulldurchgang
	_BIC_SR(GIE);								// interrupts disabled: Ton aus
}

// Ende CTCSS.c
