 /*
 * DAC_Sinus.c
 *
 *  Created on: 25.03.2013
 *      Author: DL9MWE
 *      29.3.2016
 */

#include	"main.h"

unsigned int DAC_quadrant;
unsigned int DAC_stuetzstelle;

void vDAC_init(void) {
	DAC_quadrant=0;
	DAC_stuetzstelle=0;
}

// Sinus-Tabelle; stellt eine 4tel Schwingung dar
static const unsigned int sinus_tabelle[MAXSTUETZSTELLE] = {
	0, 100, 201, 300, 399, 497, 594, 690, 783, 875,
	965, 1052, 1137, 1219, 1299, 1375, 1447, 1517, 1582, 1644,
	1702, 1756, 1805, 1850, 1891, 1927, 1959, 1986, 2008, 2025,
	2037, 2045
};

// vom Timer-Aufruf: den nchsten Wert aus der 4tel-Sinustabelle an den DAC ausgeben
void vDAC_nextSinuswert(void) {	// wird innerhalb der ISR-Routine des Timers gerufen; kurz halten!
	switch(DAC_quadrant) {		// DAC-Wert ausgeben, abhngig von dem Viertel, in dem wir uns befinden
	case 0:	MCP4921_setDAC_value(sinus_tabelle[DAC_stuetzstelle] + MAX_DAC_VALUE/2);	break;
	case 1:	MCP4921_setDAC_value(sinus_tabelle[DAC_stuetzstelle] + MAX_DAC_VALUE/2);	break;
	case 2:	MCP4921_setDAC_value(MAX_DAC_VALUE/2 - sinus_tabelle[DAC_stuetzstelle]);	break;
	case 3:	MCP4921_setDAC_value(MAX_DAC_VALUE/2 - sinus_tabelle[DAC_stuetzstelle]);	break;
	}
	switch(DAC_quadrant) {	// folgender Wert
	case 0:
	case 2:	if(++DAC_stuetzstelle >= MAXSTUETZSTELLE) {
				++DAC_quadrant;
				--DAC_stuetzstelle;
			}
	break;
	case 1:
	case 3: if(--DAC_stuetzstelle == 0) {
				if(++DAC_quadrant > 3)	{
					DAC_quadrant = 0;
				}
			}
	break;
	}
}

// Ende DAC_Sinus.c
