/*
 * MCP4921.h
 * 12Bit DAC via SPI
 *  Created on: 01.04.2013
 *      Author: DL9MWE
 *      22.03.2016
 */

#ifndef MCP4921_H_
#define MCP4921_H_

#define	MAX_DAC_VALUE	4096	// maximaler Eingabe-Wert fr 12-Bit DAC

// IO-Portbelegung fr DAC
#define PORTDAC_DIR		P2DIR
#define PORTDAC_OUT		P2OUT
#define PORTDAC_SEL		P2SEL
#define PORTDAC_SEL2	P2SEL2
#define	MCP4921_SDI		BIT3	// SDI (Pin4) an P2.3
#define	MCP4921_SCK		BIT4	// SCK (Pin3) an P2.4
#define	MCP4921__CS		BIT5	// _CS (Pin2) an P2.5

// Prototypes
void vSPI_init(void);
void vMCP4921_txWord(unsigned int data);

#define _GA		BITD
#define _SHDN	BITC
#define	MCP4921_setDAC_value(value) vMCP4921_txWord((value&0x0fff) | _GA | _SHDN)


#endif /* MCP4921_H_ */
