/*
 * main.c
 * Digital-Analog Conversion mit dem MSP430 und dem MCP4921
 * Ausgabe von DAC-Werten via SPI an den 12-Bit DAC
 *
 * Erzeugung von CTCSS-Subaudio-Tnen fr FT736 u..
 * Sinus-Schwingung niedriger Frequenz mit 4*32 Sttzstellen pro Periode
 * MSP430G2553 luft mit 16MHz
 *	Urheber DL9MWE
 *	29.03.2016
 */
#include	"main.h"

void main(void) {
	vCPU_init();
	while(42) {
		// CTCSS-Sendeton aktiv, wenn Enable und Tx == 1
		if((PORTFT736_E_TX_IN & TONESQL_E) && (PORTFT736_E_TX_IN & TONESQL_TX)) {
			vCTCSS_start();
			while(PORTFT736_E_TX_IN & TONESQL_TX) ;	// CTCSS erzeugen
			vCTCSS_end();
		}
	}
}

void vCPU_init(void) {
	WDTCTL = WDTPW + WDTHOLD;	// stop watchdog-timer
	DCOCTL = CALDCO_16MHZ;		// interner Oszillator @ 16Mhz
	BCSCTL1 = CALBC1_16MHZ;
	BCSCTL2 = 0;
	BCSCTL3 = 0;
	PORTFT736_DIR &= ~(TONESQL_S0+TONESQL_S1+TONESQL_S2+TONESQL_S3+TONESQL_S4+TONESQL_S5);
	PORTFT736_E_TX_DIR &= ~(TONESQL_E+TONESQL_TX);	// Inputs

	P3DIR  = 0x00;				//port 3 not used at all
	P3REN  = 0xff;				//use internal resistors
	P3OUT  = 0x00;				//pull down to GND
}

#pragma vector=unused_interrupts
__interrupt void unused(void) {
}

// Ende main.c
